#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_LotteryChipCFG.h"
std::auto_ptr<M_LotteryChipCFG> M_LotteryChipCFG::msSingleton(nullptr);

int M_LotteryChipCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_LotteryChipCFGData* M_LotteryChipCFG::GetData(int Recharge)
{
	auto it = mMapData.find(Recharge);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_LotteryChipCFGData>& M_LotteryChipCFG::GetMapData()
{
	return mMapData;
}

void M_LotteryChipCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_LotteryChipCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_LotteryChipCFGData data;
		data.mRecharge = element->IntAttribute("Recharge");
		data.mRechargeUp = element->IntAttribute("RechargeUp");
		data.mRetChipRate = element->IntAttribute("RetChipRate");
		data.mQuickDeduction = element->IntAttribute("QuickDeduction");
		if (mMapData.find(data.mRecharge) != mMapData.end())std::cout <<"data refind:" << data.mRecharge << std::endl;
		CCASSERT(mMapData.find(data.mRecharge) == mMapData.end(), "data.mRecharge is exists");
		mMapData.insert(std::make_pair(data.mRecharge, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_LotteryChipCFG Loaded. Load Data:%u", mMapData.size());
}

void M_LotteryChipCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_LotteryChipCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_LotteryChipCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_LotteryChipCFGData data;
		LuaCfgHelper::readInt(L, "Recharge", data.mRecharge);
		LuaCfgHelper::readInt(L, "RechargeUp", data.mRechargeUp);
		LuaCfgHelper::readInt(L, "RetChipRate", data.mRetChipRate);
		LuaCfgHelper::readInt(L, "QuickDeduction", data.mQuickDeduction);
		if (mMapData.find(data.mRecharge) != mMapData.end())std::cout <<"data refind:" << data.mRecharge << std::endl;
		CCASSERT(mMapData.find(data.mRecharge) == mMapData.end(), "data.mRecharge is exists");
		mMapData.insert(std::make_pair(data.mRecharge, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_LotteryChipCFG Loaded. Load Data:%u", mMapData.size());
}

void M_LotteryChipCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_LotteryChipCFG* M_LotteryChipCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_LotteryChipCFG());
	}
	return msSingleton.get();
}

void M_LotteryChipCFG::Release()
{
	msSingleton.reset(nullptr);
}
